/*
   Test program for PCI-12/14bit A/D,D/A,D/I,DO
*/

#include <dos.h>
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>

#include "pci.h"

#define ADC_CHANNEL	0x000F
#define ADC_SCALE	0x0070
#define ADC_SAMPLE	0x0080
#define ADC_TRIG_INT	0x0000
#define ADC_TRIG_EXT	0x0200
#define ADC_EXT_GATE	0x0400
#define ADC_INTR	0x0800
#define ADC_TRIG	0x1000
#define ADC_HOLD	(~ADC_SAMPLE)

/* set default value for ioport, CNTR */
unsigned int ioport = 0;
unsigned int picmask = 0;
unsigned long intcount = 0L;
unsigned int irq = 0;
unsigned int adbit = 12;


void testadloopback (int adbit)
{
  unsigned int adc, channel,humidity,zero=2.15;//zero is state zero volaue
  float voltage,x1,x2;//,humidity;
  int i, x, c;
  clrscr ();
  gotoxy (8, 4);
  cprintf ("Channel   voltage  hunidity sensor ");
  delay (10);
  channel = 1;
  for(;;){
      adc = channel | ADC_TRIG_INT | ADC_SAMPLE;
      outport (ioport, adc);
      delay (1);
      adc &= ADC_HOLD;
      outport (ioport, adc);
      adc |= ADC_TRIG;
      outport (ioport, adc);
      adc &= ~ADC_TRIG;
      outport (ioport, adc);
      x = inport (ioport);
      x &= 0xfff; //chake 16bit
      delay(100);
      voltage = x / 512.0; 
      delay(100);
      x1=(voltage-zero)*1000;
      humidity = x1 / 9 ;

      gotoxy (10, 5 + channel);
      cprintf ("%2d :  %7.5fV  %7d %RH ", channel + 1,voltage,humidity);

    if (kbhit ()) {
      c = getch ();
      if (c == 27)
	break;
      else if (c == ' ')
	getch ();
	 }  //if(kbhit())
    }
  getch ();
}

void main()
{
  int r;
  int flag = 1;
  char ch;

  while (flag) {
    clrscr();
    adbit = 12;
    r =  GetPCICardInfo (PCI_DEVICE_ID_12ADDA, &ioport, &irq);
    if (r)
      ioport = 0;
    if (ioport == 0) {
      cputs ("PCI-12 bit AD/DA Test Program: Can not find card!\n\r");
      break;
    }
    cputs ("\n\n\n\r");
    cputs ("                PCI-12 bit AD/DA CARD Test Program V1.1\n\r");
    cputs ("                ==========================================\n\r");
    cprintf ("                     PCI %d bit AD/DA card found.\n\r", adbit);
    cprintf ("                     I/O Address: %04X   IRQ: %d\n\r", ioport, irq);
    cputs ("\n\r");
    cputs ("                     (1): Humidity Sensor Loopback test\n\r");
    cputs ("                     ESC: EXIT\n\r");
    cputs ("                     Choose:");
    do {
      ch = getch();
    } while (ch != '1' && ch != 27);

    switch (ch) {
      case 27:
	flag = 0;
	break;
      case '1':
	testadloopback (adbit);
	break;
     }  //switch(ch)
  }
} /* end of main */
